AD_PREV	MACRO	AD_TEMP

	banksel	AD_TEMP		;Nastavil jsem banku AD_TEMP
	MOVWF	AD_TEMP
	SWAPF	AD_TEMP,F
	RRF	AD_TEMP,W
	ANDLW	B'00111000'	;Ulozil jsem W do AD_TEMP a provedl pouhy posun o tri bity doleva, vystup skoncil ve W.
	banksel	ADCON0
	BCF	ADCON0,5
	BCF	ADCON0,4
	BCF	ADCON0,3		;Bity, ktere definuji aktualni kanal je treba nejprve vynulovat.
	IORWF	ADCON0,F		;Pomoci W byl nastaven zadouci A/D kanal.
	banksel	AD_TEMP
	MOVLW	34
	MOVWF	AD_TEMP
	DECFSZ	AD_TEMP,F
	GOTO	$ - 1		;Uplynula prodleva alespon 20 mikrosekund (tedy 100 cyklu).
	banksel	ADCON0
	BSF	ADCON0,GO		;Zahajil jsem A/D prevod.
	BTFSC	ADCON0,GO
	GOTO	$ - 1		;cekam na konec prevodu (az se bit GO automaticky vynuluje).
	banksel	0
	RETURN

	ENDM


N_PREV	MACRO	AD_TEMP,ADRESL_,ADRESH_,AD_COUNT,BITS

	LOCAL	N_LOOP

	banksel	AD_TEMP
	MOVWF	AD_TEMP
	SWAPF	AD_TEMP,F
	RRF	AD_TEMP,W
	ANDLW	B'00111000'
	banksel	ADCON0
	BCF	ADCON0,5
	BCF	ADCON0,4
	BCF	ADCON0,3
	IORWF	ADCON0,F
	banksel	ADRESL_
	CLRF	ADRESL_		; Priprav prazdnou sumu ADRES_
	CLRF	ADRESH_
	MOVLW	64
	MOVWF	AD_COUNT		; Nastav 64 opakovani
N_LOOP	MOVLW	34		; Zakladni A/D prevod
	MOVWF	AD_TEMP
	DECFSZ	AD_TEMP,F
	GOTO	$ - 1
	banksel	ADCON0
	BSF	ADCON0,GO
	BTFSC	ADCON0,GO
	GOTO	$ - 1
	banksel	ADRESL
	MOVF	ADRESL,W
	banksel	ADRESL_
	ADDWF	ADRESL_,F
	BTFSC	STATUS,C
	INCF	ADRESH_,F
	banksel	ADRESH
	MOVF	ADRESH,W
	banksel	ADRESH_
	ADDWF	ADRESH_,F
	DECFSZ	AD_COUNT,F
	GOTO	N_LOOP
	IF BITS<=0
	RRF	ADRESH_,F		; 64 opakovani provedeno...
	RRF	ADRESL_,F		; ...proved deleni bitovym posunem
	ENDIF
	IF BITS<=1
	RRF	ADRESH_,F
	RRF	ADRESL_,F
	ENDIF
	IF BITS<=2
	RRF	ADRESH_,F
	RRF	ADRESL_,F
	ENDIF
	IF BITS<=3
	RRF	ADRESH_,F
	RRF	ADRESL_,F
	ENDIF
	IF BITS<=4
	RRF	ADRESH_,F
	RRF	ADRESL_,F
	ENDIF
	RRF	ADRESH_,W
	IF BITS==0
	ANDLW	B'00000011'	; oriznuti "necistot"
	ENDIF
	IF BITS==1
	ANDLW	B'00000111'	; oriznuti "necistot"
	ENDIF
	IF BITS==2
	ANDLW	B'00001111'	; oriznuti "necistot"
	ENDIF
	IF BITS==3
	ANDLW	B'00011111'	; oriznuti "necistot"
	ENDIF
	IF BITS==4
	ANDLW	B'00111111'	; oriznuti "necistot"
	ENDIF
	banksel	ADRESH
	MOVWF	ADRESH
	banksel	ADRESL_
	RRF	ADRESL_,W
	banksel	ADRESL
	MOVWF	ADRESL
	banksel	0		; vysledek je v ADRESL a ADRESH
	RETURN
	
	ENDM


H_PREV	MACRO	AD_TEMP,ADRESL_,ADRESH_,AD_COUNT,ADRESL_A,ADRESL_B,ADRESH_A,ADRESH_B,BITS

	LOCAL	H_LOOP, SKOK_00, SKOK_01, SKOK_02

	banksel	AD_TEMP
	MOVWF	AD_TEMP
	SWAPF	AD_TEMP,F
	RRF	AD_TEMP,W
	ANDLW	B'00111000'
	banksel	ADCON0
	BCF	ADCON0,5
	BCF	ADCON0,4
	BCF	ADCON0,3
	IORWF	ADCON0,F
	banksel	ADRESL_
	CLRF	ADRESL_
	CLRF	ADRESH_
	MOVLW	D'64'
	MOVWF	AD_COUNT
H_LOOP	MOVLW	D'34'
	MOVWF	AD_TEMP
	DECFSZ	AD_TEMP,F
	GOTO	$ - 1
	banksel	ADCON0
	BSF	ADCON0,GO
	BTFSC	ADCON0,GO
	GOTO	$ - 1
	banksel	ADRESL
	MOVF	ADRESL,W
	banksel	ADRESL_
	ADDWF	ADRESL_,F
	BTFSC	STATUS,C
	INCF	ADRESH_,F
	banksel	ADRESH
	MOVF	ADRESH,W
	banksel	ADRESH_
	ADDWF	ADRESH_,F
	DECFSZ	AD_COUNT,F
	GOTO	H_LOOP

	MOVF	ADRESL_,W		; duplikace ADRES_
	MOVWF	ADRESL_A
	MOVF	ADRESH_,W
	MOVWF	ADRESH_A

	MOVF	ADRESL_B,W	; vypocet rozdilu
	SUBWF	ADRESL_A,F
	MOVF	ADRESH_B,W
	BTFSS	STATUS,C
	INCFSZ	ADRESH_B,W
	SUBWF	ADRESH_A,F
	BTFSC	STATUS,C
	GOTO	SKOK_00
	MOVF	ADRESH_A,W	; pokud je vysledek zaporny...
	XORLW	D'255'		; ...bude preveden na kladny
	MOVWF	ADRESH_A
	MOVF	ADRESL_A,W
	XORLW	D'255'
	MOVWF	ADRESL_A
	INCF	ADRESL_A,F
	BTFSC	STATUS,Z
	INCF	ADRESH_A,F
SKOK_00	MOVF	ADRESH_A,F	; Je vysledek dost velky?...
	BTFSS	STATUS,Z
	GOTO	SKOK_01
	MOVF	ADRESL_A,W
	IF BITS==0
	ANDLW	B'11000000'
	ENDIF
	IF BITS==1
	ANDLW	B'11100000'
	ENDIF
	IF BITS==2
	ANDLW	B'11110000'
	ENDIF
	IF BITS==3
	ANDLW	B'11111000'
	ENDIF
	IF BITS==4
	ANDLW	B'11111100'
	ENDIF
	BTFSC	STATUS,Z
	GOTO	SKOK_02
SKOK_01	MOVF	ADRESL_,W		; ...pokud ano, potom je nova hodnota pouzita
	MOVWF	ADRESL_B
	MOVF	ADRESH_,W
	MOVWF	ADRESH_B
SKOK_02	RRF	ADRESH_B,W	; deleni posunem a zapis do ADRESL,ADRESH
	MOVWF	ADRESH_
	RRF	ADRESL_B,W
	MOVWF	ADRESL_
	IF BITS<0
	RRF	ADRESH_,F		; 64 opakovani provedeno...
	RRF	ADRESL_,F		; ...proved deleni bitovym posunem
	ENDIF
	IF BITS<1
	RRF	ADRESH_,F
	RRF	ADRESL_,F
	ENDIF
	IF BITS<2
	RRF	ADRESH_,F
	RRF	ADRESL_,F
	ENDIF
	IF BITS<3
	RRF	ADRESH_,F
	RRF	ADRESL_,F
	ENDIF
	IF BITS<4
	RRF	ADRESH_,F
	RRF	ADRESL_,F
	ENDIF
	RRF	ADRESH_,W
	IF BITS==0
	ANDLW	B'00000011'	; oriznuti "necistot"
	ENDIF
	IF BITS==1
	ANDLW	B'00000111'	; oriznuti "necistot"
	ENDIF
	IF BITS==2
	ANDLW	B'00001111'	; oriznuti "necistot"
	ENDIF
	IF BITS==3
	ANDLW	B'00011111'	; oriznuti "necistot"
	ENDIF
	IF BITS==4
	ANDLW	B'00111111'	; oriznuti "necistot"
	ENDIF
	banksel	ADRESH
	MOVWF	ADRESH
	banksel	ADRESL_
	RRF	ADRESL_,W
	banksel	ADRESL
	MOVWF	ADRESL
	banksel	0
	RETURN

	ENDM
